<?php


class mabnaClass{
    
    public static function setMabna($Amount,$mid,$terminal,$revertURL)
	{
		   $pat = dirname(__FILE__);
			if(!function_exists('timestamp_to_iso8601'))
			{
				include_once($pat.'/nusoap.php');
			}
			
			$amount = trim($Amount);
			$client = new nusoap_client("https://mabna.shaparak.ir/TokenService?wsdl", 'wsdl');
			$invoiceNumber = time();
			$merchant = trim($mid);
			$redirectAddress = $revertURL; 
			$terminal = trim($terminal);
			$source = $amount.$invoiceNumber.$merchant.$redirectAddress.$terminal;
			$session = JFactory::getSession();
			$session->set('amount',$amount); 
			 
			$fp = fopen($pat . '/public.txt', "r");
			$pub_key = fread($fp, 8192);
			fclose($fp);
			if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
				$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

			if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
				$pub_key .= "\n-----END PUBLIC KEY-----";
			
			
			$key_resource=openssl_get_publickey($pub_key);
			
			// Amount
			openssl_public_encrypt($amount, $crypttext, $key_resource );
			$Amount = base64_encode($crypttext);
			 
			 // CRN
			openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource );
			$CRN = base64_encode($crypttext);

			// MID
			openssl_public_encrypt($merchant, $crypttext, $key_resource );
			$MID = base64_encode($crypttext);

			// TID
			openssl_public_encrypt($terminal, $crypttext, $key_resource );
			$TID = base64_encode($crypttext);

			// TID
			openssl_public_encrypt($redirectAddress, $crypttext, $key_resource );
			$referal = base64_encode($crypttext);

			$key = file_get_contents($pat . '/private.txt');

			if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
				$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

			if (strpos($key, '-----END PRIVATE KEY-----') === false)
				$key .= "\n-----END PRIVATE KEY-----";
			
			$priv_key = openssl_pkey_get_private($key);
			$signature = '';
			
			openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
			$inputArray = array("Token_param" => array("AMOUNT" => $Amount, "CRN"    => $CRN, "MID"    => $MID, 
			"REFERALADRESS" => $redirectAddress, "SIGNATURE" => base64_encode($signature), "TID" => $TID));
			
			$WSResult = $client->call("reservation", $inputArray);
			$signature = base64_decode($WSResult['return']['signature']);
			$ok = openssl_verify($WSResult["return"]["token"], $signature, $key_resource);
			openssl_free_key($key_resource);

		
			if ($ok == 1 && $WSResult['return']['result'] == 0) 
			{
				$setPayment = '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir" method="POST">
				<input type="hidden" id="TOKEN" name="TOKEN" value="'.$WSResult["return"]["token"].'">
				</form><script>
				function submitmabna() {
				document.getElementById("paymentUTLfrm").submit();
				}
				window.onload=submitmabna; </script>';

			}
			else
			{
				$setPayment =  var_export($WSResult["return"],true);
			}
        
			return $setPayment;
    }
    
    public static function getMabna($POST,$mid)
	{
        
		$merchant 	= trim($mid);
		$session = JFactory::getSession();
		if( isset($POST['CRN']) && isset($POST['TRN']) && isset($POST['RESCODE']) && $POST['RESCODE'] == '00' )
		{
			$pat = dirname(__FILE__);
			if(!function_exists('timestamp_to_iso8601'))
			{
				include_once($pat . '/nusoap.php');
			}
			$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
			$error = $client->getError();
			$pat = dirname(__FILE__);
			$fp = fopen($pat . '/public.txt', "r");
			$pub_key = fread($fp, 8192);
			fclose($fp);
			if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
				$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

			if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
				$pub_key .= "\n-----END PUBLIC KEY-----";

			$key_resource = openssl_get_publickey($pub_key);

			openssl_public_encrypt($POST["TRN"], $crypttext, $key_resource );
			$TRN = base64_encode($crypttext);

			// CRN
			openssl_public_encrypt($POST["CRN"], $crypttext, $key_resource );
			$CRN = base64_encode($crypttext);

			// MID
			openssl_public_encrypt($merchant, $crypttext, $key_resource );
			$MID = base64_encode($crypttext);

			// Sign data
			$source = $merchant.$POST["TRN"].$POST["CRN"];
			
			$key = file_get_contents($pat . '/private.txt');

			if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
				$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

			if (strpos($key, '-----END PRIVATE KEY-----') === false)
				$key .= "\n-----END PRIVATE KEY-----";
		
			$priv_key = openssl_pkey_get_private($key);
			$signature = '';
			openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
			$inputArray = array("SaleConf_req" => array("MID"    => $MID,
														"CRN"    => $CRN,
														"TRN"    => $TRN,
														"SIGNATURE" => base64_encode($signature)));
			$WSResult = $client->call("sendConfirmation", $inputArray);
			$error = $client->getError();
			$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
			$data      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];

			$ok = openssl_verify($data, $signature, $key_resource);
			if ($ok == 1) 
			{
				 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
				 {

					$amount = $session->get('amount');
					if($WSResult["return"]["AMOUNT"] == $amount)
					{
						$session->set('amount',0);
						$referenceId = $WSResult["return"]["TRN"];
						return array(1,"با تشکر پرداخت شما با موفقت انجام شد. شماره تراکنش پرداخت: $referenceId",$referenceId);
					}else
					{
						$session->set('amount',0);
						return array(0,"مبلغ پرداختی با قیمت کالا برابر نیست .");
					}
				} else 
				{
					$session->set('amount',0);
					return array(0,"خطا در وریفای");
				}
			
			} else 
			{
				$session->set('amount',0); 
				return array(0,"خطا در کدینگ نتیجه");
			}

			openssl_free_key($key_resource);
		}else
		{
			$session->set('amount',0);
			return array(0,"پرداخت ناموفق بود");
		}
		
    }
    
}

?>